#include <stdio.h>
#include <malloc.h>
#include <jpeglib.h>

unsigned char *
Sld_read_jpeg(filename, width, height)
     char *filename;
     int *width, *height;
{
    struct jpeg_decompress_struct cinfo;
    struct jpeg_error_mgr jerr;
    unsigned char *data, *line[16], *ptr;
    int x, y, i, h, w;
    FILE *f;

    f = fopen(filename, "r");
    cinfo.err = jpeg_std_error(&jerr);
    jpeg_create_decompress(&cinfo);
    jpeg_stdio_src(&cinfo, f);
    jpeg_read_header(&cinfo, TRUE);
    cinfo.do_fancy_upsampling = FALSE;
    cinfo.do_block_smoothing = FALSE;
    jpeg_start_decompress(&cinfo);
    *width = w = cinfo.output_width;
    *height = h = cinfo.output_height;
    data = malloc(w * h * 3);
    if (!data) {
	jpeg_destroy_decompress(&cinfo);
	return NULL;
    }

    ptr = data;
    if (cinfo.output_components == 3) {
	for (y = 0; y < h; y += cinfo.rec_outbuf_height) {
	    for (i = 0; i < cinfo.rec_outbuf_height; i++) {
		line[i] = ptr;
		ptr += w * 3;
	    }
	    jpeg_read_scanlines(&cinfo, line, cinfo.rec_outbuf_height);
	}
    }
    else if (cinfo.output_components == 1) {
	for (i = 0; i < cinfo.rec_outbuf_height; i++)
	    line[i] = malloc(w);
	for (y = 0; y < h; y += cinfo.rec_outbuf_height) {
	    jpeg_read_scanlines(&cinfo, line, cinfo.rec_outbuf_height);
	    for (i = 0; i < cinfo.rec_outbuf_height; i++) {
		for (x = 0; x < w; x++) {
		    *ptr++ = line[i][x];
		    *ptr++ = line[i][x];
		    *ptr++ = line[i][x];
		}
	    }
	}
	for (i = 0; i < cinfo.rec_outbuf_height; i++)
	    free(line[i]);
    }
    jpeg_finish_decompress(&cinfo);
    jpeg_destroy_decompress(&cinfo);
    fclose(f);
    return data;
}

void
Sld_write_jpeg(data, filename, width, height)
    char *data;
    char *filename;
    int width;
    int height;
{
	struct jpeg_compress_struct cinfo;
	struct jpeg_error_mgr jerr;
	JSAMPROW row_pointer[1];
	int row_stride;
	int y;
	FILE *f;
	
	f=fopen(filename,"wb");
	if (f)
	  {
	     cinfo.err = jpeg_std_error(&jerr);
	     jpeg_create_compress(&cinfo);
	     jpeg_stdio_dest(&cinfo,f);
	     cinfo.image_width=width;
	     cinfo.image_height=height;
	     cinfo.input_components=3;
	     cinfo.in_color_space=JCS_RGB;
	     jpeg_set_defaults(&cinfo);
	     jpeg_set_quality(&cinfo,7500,TRUE);
	     jpeg_start_compress(&cinfo,TRUE);
	     row_stride=cinfo.image_width*cinfo.input_components;
	     while (cinfo.next_scanline<cinfo.image_height)
	       {
    		  row_pointer[0]=&data[cinfo.next_scanline*row_stride];
	    	  jpeg_write_scanlines(&cinfo,row_pointer,1);
	       }
	     jpeg_finish_compress(&cinfo);
	     fclose(f);
	  }
}
