/*
 * sldDrawText.c -- text drawing and rotation routines
 */

#include <tk.h>
#include <math.h>
#include "sldExternals.h"
#include "slide.h"

void Sld_DrawText( slidePtr, d, itemPtr, xoff, yoff )
Slide *slidePtr;
Drawable d;
SldItem *itemPtr;
int xoff,yoff;
{
	GC gc,gc1,gc2;
	XGCValues gcv;
	int zoom=slidePtr->zoom;
	int rot=itemPtr->rotate;
    char fontname[80],*s;
    int fsize;
    Tk_Font tkfont;
    Pixmap p;
    double costheta,sintheta;
    int x1=itemPtr->x1,y1=itemPtr->y1;
    int x2=itemPtr->x2,y2=itemPtr->y2;
    int pw,ph,x,y,yput,xx,yy,iw,ih;
    unsigned long white,black;
    XImage *xi;
	Tk_FontMetrics fm;
          
    strcpy(fontname,Tk_NameOfFont(itemPtr->tkfont));
    s=strrchr(fontname,' ')+1;
    sscanf(s,"%d",&fsize);
    sprintf(s,"%d",fsize*zoom/16);
    tkfont = Tk_GetFont(slidePtr->interp,slidePtr->tkwin,fontname);
   	Tk_GetFontMetrics(itemPtr->tkfont, &fm);
    if (rot) {
        white = WhitePixel(Tk_Display(slidePtr->tkwin), 
    	    Tk_ScreenNumber(slidePtr->tkwin));
        black = BlackPixel(Tk_Display(slidePtr->tkwin), 
    	    Tk_ScreenNumber(slidePtr->tkwin));
        pw=(x2-x1)*zoom/16;
        ph=(y1-y2)*zoom/16;
    	gcv.foreground = white;
    	gcv.background = black; 
        gcv.font = Tk_FontId(tkfont);
        gc1 = Tk_GetGC(slidePtr->tkwin, 
            GCForeground | GCBackground | GCFont, &gcv);
    	gcv.foreground = black;
    	gcv.background = white; 
        gcv.font = Tk_FontId(tkfont);
        gc2 = Tk_GetGC(slidePtr->tkwin, 
            GCForeground | GCBackground | GCFont, &gcv);
    	gcv.foreground = itemPtr->color->pixel;
        gcv.font = Tk_FontId(tkfont);
        gc = Tk_GetGC(slidePtr->tkwin, GCForeground | GCFont, &gcv);

        costheta = cos(rot*6.28/360.);
        sintheta = sin(rot*6.28/360.);
        iw = (int)(pw*costheta+ph*sintheta);
        ih = (int)(pw*sintheta+ph*costheta);
        p=Tk_GetPixmap(slidePtr->display,Tk_WindowId(slidePtr->tkwin),
            pw,ph,Tk_Depth(slidePtr->tkwin));
        XFillRectangle(slidePtr->display,p,gc1,0,0,pw,ph);   
        Tk_DrawChars(slidePtr->display, p, gc2, itemPtr->tkfont,
	        itemPtr->text, strlen(itemPtr->text),0,ph-fm.descent );
        xi = XGetImage(slidePtr->display,p,0,0,pw,ph,AllPlanes,ZPixmap);

        yput = y1-fm.ascent+fm.descent;

        /* fill in the rotated pixmap */
        for (x=-(pw+ph);x<(pw+ph);x++) {
            for (y=-(pw+ph);y<(pw+ph);y++) {
                xx = (int)(x*costheta-y*sintheta+
                    fm.ascent*sintheta);
                yy = (int)(x*sintheta+y*costheta+
                    fm.ascent*(1-costheta));
                if (xx>=0 && xx<=pw && yy>=0 && yy<=ph) {
                    if (XGetPixel(xi,xx,yy) == black)
                        XDrawPoint(slidePtr->display,d,gc,
                            x+x1*zoom/16-xoff, y+yput*zoom/16-yoff);
                }  
            }
        }
        Tk_FreePixmap(slidePtr->display,p);
        Tk_FreeGC(slidePtr->display, gc2);
        Tk_FreeGC(slidePtr->display, gc1);
        XDestroyImage(xi);
    }
    else {
    	gcv.foreground = itemPtr->color->pixel;
        gcv.font = Tk_FontId(tkfont);
        gc = Tk_GetGC(slidePtr->tkwin, GCForeground | GCFont, &gcv);
        Tk_DrawChars(slidePtr->display, d, gc, itemPtr->tkfont,
	        itemPtr->text, strlen(itemPtr->text),
	        x1*zoom/16-xoff, (y1-fm.descent)*zoom/16-yoff);
	}
    Tk_FreeFont(tkfont);
    Tk_FreeGC(slidePtr->display, gc);
}
