/* 
 */

#include <tk.h>
#include "sldExternals.h"
#include "slide.h"

int
Sld_ps_output( slidePtr, filename )
Slide *slidePtr;
char *filename;
{
	Tk_Window tkwin = slidePtr->tkwin;
	Pixmap d = None;
	char rl,rh,gl,gh,bl,bh;
	unsigned char rv,gv,bv;
	FILE *outfile;
	int x, y, h, w, i, c, new;
	SldLayer *layerPtr;
    XImage *xi;
    unsigned long pixel;
    Tcl_HashTable colorTable;
    XColor *colorPtr;
    Tcl_HashEntry *entryPtr;
    Tcl_HashSearch search;

    Tcl_InitHashTable(&colorTable,TCL_ONE_WORD_KEYS);
    w = slidePtr->sWidth;
    h = slidePtr->sHeight;
    /*
     * draw in a temporary pixmap
     */
	d = Tk_GetPixmap(Tk_Display(tkwin), Tk_WindowId(tkwin),
			 w, h, DefaultDepthOfScreen(Tk_Screen(tkwin)));
	XCopyArea(Tk_Display(tkwin), slidePtr->backPixmap, d,
		  slidePtr->gc, 0, 0, w, h, 0, 0);
	/*
	 * paint all enabled layers
	 */
	for (layerPtr = slidePtr->firstLayer; layerPtr != NULL;
	     layerPtr = layerPtr->nextLayer) {
		if (layerPtr->visible)
			Sld_DisplayLayer(slidePtr, d, layerPtr);
	}
    xi = XGetImage(slidePtr->display,d,0,0,w,h,AllPlanes,ZPixmap);
	Tk_FreePixmap(Tk_Display(tkwin), d);

    /* write postscript file */
    if ((outfile = fopen(filename,"wb")) == NULL) {
        return TCL_ERROR;
    }
    fprintf(outfile,"/pix %i string def\n",3*w);
    fprintf(outfile,"%i %i 8\n",w,h);
    fprintf(outfile,"[1 0 0 -1 -1 780]\n");
    fprintf(outfile,"{currentfile pix readhexstring pop}\n");
    fprintf(outfile,"false 3 colorimage\n");

    for (y = 0; y < h; y++) {
	    for (x = 0; x < w; x++) {
	        pixel = XGetPixel(xi, x, y);
            if ((entryPtr = Tcl_FindHashEntry(&colorTable,
                (char *)pixel)) == NULL) {
                entryPtr = Tcl_CreateHashEntry(&colorTable,
                    (char *)pixel,&new);
                colorPtr = (XColor *) malloc(sizeof(XColor));
                colorPtr->pixel = pixel;
                XQueryColor(Tk_Display(tkwin),Tk_Colormap(tkwin),colorPtr);
                Tcl_SetHashValue( entryPtr, colorPtr );
            }               
            else {
                colorPtr = Tcl_GetHashValue(entryPtr);
            }
            rv = colorPtr->red >> 8;
            gv = colorPtr->green >> 8;
            bv = colorPtr->blue >> 8;

            /* convert values to hex digits */
            rh = ((rv&0xf0)>>4)+'0';
            rl = ((rv&0x0f))+'0';
            if (rh>'9') rh+='a'-'0'-10;
            if (rl>'9') rl+='a'-'0'-10;
            gh = ((gv&0xf0)>>4)+'0';
            gl = ((gv&0x0f))+'0';
            if (gh>'9') gh+='a'-'0'-10;
            if (gl>'9') gl+='a'-'0'-10;
            bh = ((bv&0xf0)>>4)+'0';
            bl = ((bv&0x0f))+'0';
            if (bh>'9') bh+='a'-'0'-10;
            if (bl>'9') bl+='a'-'0'-10;
            fprintf(outfile,"%c%c%c%c%c%c",rh,rl,gh,gl,bh,bl);
	    }
	    fprintf(outfile,"\n");
    }    
    fprintf(outfile,"showpage\n");
    fclose(outfile);

    /* clean up structs and free storage */
    XDestroyImage(xi);
    /* delete hash table entries before leaving */
    for (entryPtr=Tcl_FirstHashEntry(&colorTable,&search);
        entryPtr!=NULL; entryPtr=Tcl_NextHashEntry(&search)) {
            colorPtr = (XColor *)Tcl_GetHashValue(entryPtr);
            free(colorPtr);
    }
    Tcl_DeleteHashTable(&colorTable);
    return TCL_OK;
}
